var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { ChangeDetectionStrategy, Component, ContentChild, ContentChildren, Directive, ElementRef, Injector, NgModule, Renderer2, ViewContainerRef } from '@angular/core';
import { ArrayBase, ComplexBase, ComponentBase, ComponentMixins, Template, setValue } from '@syncfusion/ej2-angular-base';
import { ProgressAnnotation, ProgressBar, ProgressTooltip } from '@syncfusion/ej2-progressbar';
import { CommonModule } from '@angular/common';
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
        r = Reflect.decorate(decorators, target, key, desc);
    else
        for (var i = decorators.length - 1; i >= 0; i--)
            if (d = decorators[i])
                r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
        return Reflect.metadata(k, v);
};
var input = ['annotationAngle', 'annotationRadius', 'content'];
var outputs = [];
/**
 * ProgressBarAnnotations Directive
 * ```html
 * <e-progressbar-annotations>
 * <e-progressbar-annotation></e-progressbar-annotation>
 * </e-progressbar-annotations>
 * ```
 */
var ProgressBarAnnotationDirective = /** @class */ (function (_super) {
    __extends(ProgressBarAnnotationDirective, _super);
    /**
     * @param {?} viewContainerRef
     */
    function ProgressBarAnnotationDirective(viewContainerRef) {
        var _this = _super.call(this) || this;
        _this.viewContainerRef = viewContainerRef;
        setValue('currentInstance', _this, _this.viewContainerRef);
        _this.registerEvents(outputs);
        _this.directivePropList = input;
        return _this;
    }
    return ProgressBarAnnotationDirective;
}(ComplexBase));
ProgressBarAnnotationDirective.decorators = [
    { type: Directive, args: [{
                selector: 'e-progressbar-annotations>e-progressbar-annotation',
                inputs: input,
                outputs: outputs,
                queries: {}
            },] },
];
/**
 * @nocollapse
 */
ProgressBarAnnotationDirective.ctorParameters = function () { return [
    { type: ViewContainerRef, },
]; };
ProgressBarAnnotationDirective.propDecorators = {
    'content': [{ type: ContentChild, args: ['content',] },],
};
__decorate([
    Template(),
    __metadata("design:type", Object)
], ProgressBarAnnotationDirective.prototype, "content", void 0);
/**
 * ProgressBarAnnotation Array Directive
 */
var ProgressBarAnnotationsDirective = /** @class */ (function (_super) {
    __extends(ProgressBarAnnotationsDirective, _super);
    function ProgressBarAnnotationsDirective() {
        return _super.call(this, 'annotations') || this;
    }
    return ProgressBarAnnotationsDirective;
}(ArrayBase));
ProgressBarAnnotationsDirective.decorators = [
    { type: Directive, args: [{
                selector: 'ej-progressbar>e-progressbar-annotations',
                queries: {
                    children: new ContentChildren(ProgressBarAnnotationDirective)
                },
            },] },
];
/**
 * @nocollapse
 */
ProgressBarAnnotationsDirective.ctorParameters = function () { return []; };
var input$1 = ['color', 'end', 'start'];
var outputs$1 = [];
var RangeColorDirective = /** @class */ (function (_super) {
    __extends(RangeColorDirective, _super);
    /**
     * @param {?} viewContainerRef
     */
    function RangeColorDirective(viewContainerRef) {
        var _this = _super.call(this) || this;
        _this.viewContainerRef = viewContainerRef;
        setValue('currentInstance', _this, _this.viewContainerRef);
        _this.registerEvents(outputs$1);
        _this.directivePropList = input$1;
        return _this;
    }
    return RangeColorDirective;
}(ComplexBase));
RangeColorDirective.decorators = [
    { type: Directive, args: [{
                selector: 'e-rangecolors>e-rangecolor',
                inputs: input$1,
                outputs: outputs$1,
                queries: {}
            },] },
];
/**
 * @nocollapse
 */
RangeColorDirective.ctorParameters = function () { return [
    { type: ViewContainerRef, },
]; };
/**
 * RangeColor Array Directive
 */
var RangeColorsDirective = /** @class */ (function (_super) {
    __extends(RangeColorsDirective, _super);
    function RangeColorsDirective() {
        return _super.call(this, 'rangecolors') || this;
    }
    return RangeColorsDirective;
}(ArrayBase));
RangeColorsDirective.decorators = [
    { type: Directive, args: [{
                selector: 'ejs-progressbar>e-rangecolors',
                queries: {
                    children: new ContentChildren(RangeColorDirective)
                },
            },] },
];
/**
 * @nocollapse
 */
RangeColorsDirective.ctorParameters = function () { return []; };
var __decorate$1 = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
        r = Reflect.decorate(decorators, target, key, desc);
    else
        for (var i = decorators.length - 1; i >= 0; i--)
            if (d = decorators[i])
                r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata$1 = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
        return Reflect.metadata(k, v);
};
var inputs = ['animation', 'annotations', 'cornerRadius', 'enablePersistence', 'enablePieProgress', 'enableProgressSegments', 'enableRtl', 'endAngle', 'gapWidth', 'height', 'innerRadius', 'isActive', 'isGradient', 'isIndeterminate', 'isStriped', 'labelOnTrack', 'labelStyle', 'locale', 'margin', 'maximum', 'minimum', 'progressColor', 'progressThickness', 'radius', 'rangeColors', 'role', 'secondaryProgress', 'secondaryProgressColor', 'secondaryProgressThickness', 'segmentColor', 'segmentCount', 'showProgressValue', 'startAngle', 'theme', 'tooltip', 'trackColor', 'trackThickness', 'type', 'value', 'width'];
var outputs$2 = ['animationComplete', 'load', 'loaded', 'mouseClick', 'mouseDown', 'mouseLeave', 'mouseMove', 'mouseUp', 'progressCompleted', 'textRender', 'tooltipRender', 'valueChanged'];
var twoWays = [''];
/**
 * ProgressBar Component
 * ```html
 * <ejsprogressbar></ejsprogressbar>
 * ```
 */
var ProgressBarComponent = /** @class */ (function (_super) {
    __extends(ProgressBarComponent, _super);
    /**
     * @param {?} ngEle
     * @param {?} srenderer
     * @param {?} viewContainerRef
     * @param {?} injector
     */
    function ProgressBarComponent(ngEle, srenderer, viewContainerRef, injector) {
        var _this = _super.call(this) || this;
        _this.ngEle = ngEle;
        _this.srenderer = srenderer;
        _this.viewContainerRef = viewContainerRef;
        _this.injector = injector;
        _this.tags = ['annotations', 'rangeColors'];
        _this.element = _this.ngEle.nativeElement;
        _this.injectedModules = _this.injectedModules || [];
        try {
            var mod = _this.injector.get('ProgressBarProgressAnnotation');
            if (_this.injectedModules.indexOf(mod) === -1) {
                _this.injectedModules.push(mod);
            }
        }
        catch (_a) { }
        try {
            var mod = _this.injector.get('ProgressBarProgressTooltip');
            if (_this.injectedModules.indexOf(mod) === -1) {
                _this.injectedModules.push(mod);
            }
        }
        catch (_b) { }
        _this.registerEvents(outputs$2);
        _this.addTwoWay.call(_this, twoWays);
        setValue('currentInstance', _this, _this.viewContainerRef);
        _this.context = new ComponentBase();
        return _this;
    }
    /**
     * @return {?}
     */
    ProgressBarComponent.prototype.ngOnInit = function () {
        this.context.ngOnInit(this);
    };
    /**
     * @return {?}
     */
    ProgressBarComponent.prototype.ngAfterViewInit = function () {
        this.context.ngAfterViewInit(this);
    };
    /**
     * @return {?}
     */
    ProgressBarComponent.prototype.ngOnDestroy = function () {
        this.context.ngOnDestroy(this);
    };
    /**
     * @return {?}
     */
    ProgressBarComponent.prototype.ngAfterContentChecked = function () {
        this.tagObjects[0].instance = this.childAnnotations;
        if (this.childRangeColors) {
            this.tagObjects[1].instance = /** @type {?} */ (this.childRangeColors);
        }
        this.context.ngAfterContentChecked(this);
    };
    return ProgressBarComponent;
}(ProgressBar));
ProgressBarComponent.decorators = [
    { type: Component, args: [{
                selector: 'ejs-progressbar',
                inputs: inputs,
                outputs: outputs$2,
                template: '',
                changeDetection: ChangeDetectionStrategy.OnPush,
                queries: {
                    childAnnotations: new ContentChild(ProgressBarAnnotationsDirective),
                    childRangeColors: new ContentChild(RangeColorsDirective)
                }
            },] },
];
/**
 * @nocollapse
 */
ProgressBarComponent.ctorParameters = function () { return [
    { type: ElementRef, },
    { type: Renderer2, },
    { type: ViewContainerRef, },
    { type: Injector, },
]; };
ProgressBarComponent = __decorate$1([
    ComponentMixins([ComponentBase]),
    __metadata$1("design:paramtypes", [ElementRef,
        Renderer2,
        ViewContainerRef,
        Injector])
], ProgressBarComponent);
/**
 * NgModule definition for the ProgressBar component.
 */
var ProgressBarModule = /** @class */ (function () {
    function ProgressBarModule() {
    }
    return ProgressBarModule;
}());
ProgressBarModule.decorators = [
    { type: NgModule, args: [{
                imports: [CommonModule],
                declarations: [
                    ProgressBarComponent,
                    ProgressBarAnnotationDirective,
                    ProgressBarAnnotationsDirective,
                    RangeColorDirective,
                    RangeColorsDirective
                ],
                exports: [
                    ProgressBarComponent,
                    ProgressBarAnnotationDirective,
                    ProgressBarAnnotationsDirective,
                    RangeColorDirective,
                    RangeColorsDirective
                ]
            },] },
];
/**
 * @nocollapse
 */
ProgressBarModule.ctorParameters = function () { return []; };
var ProgressAnnotationService = { provide: 'ProgressBarProgressAnnotation', useValue: ProgressAnnotation };
var ProgressTooltipService = { provide: 'ProgressBarProgressTooltip', useValue: ProgressTooltip };
/**
 * NgModule definition for the ProgressBar component with providers.
 */
var ProgressBarAllModule = /** @class */ (function () {
    function ProgressBarAllModule() {
    }
    return ProgressBarAllModule;
}());
ProgressBarAllModule.decorators = [
    { type: NgModule, args: [{
                imports: [CommonModule, ProgressBarModule],
                exports: [
                    ProgressBarModule
                ],
                providers: [
                    ProgressAnnotationService,
                    ProgressTooltipService
                ]
            },] },
];
/**
 * @nocollapse
 */
ProgressBarAllModule.ctorParameters = function () { return []; };
/**
 * Generated bundle index. Do not edit.
 */
export { ProgressBarAnnotationDirective, ProgressBarAnnotationsDirective, RangeColorDirective, RangeColorsDirective, ProgressBarComponent, ProgressBarModule, ProgressBarAllModule, ProgressAnnotationService, ProgressTooltipService, inputs as ɵa, outputs$2 as ɵb };
export { ProgressBar, Margin, Font, Animation, ProgressAnnotationSettings, Border, TooltipSettings, RangeColor, ProgressAnnotation, ProgressTooltip, Rect, Size, Pos, RectOption, ColorValue, convertToHexCode, componentToHex, convertHexToColor, colorNameToHex, TextOption, degreeToLocation, getPathArc, stringToNumber, setAttributes, effect, annotationRender, getElement, removeElement, ProgressLocation, ProgressAnimation } from '@syncfusion/ej2-progressbar';
//# sourceMappingURL=ej2-angular-progressbar.es5.js.map
